<?php
namespace Mirakl\MMP\OperatorShop\Request\Payment\Invoice;

use Mirakl\Core\Request\AbstractRequest;
use Mirakl\Core\Request\DateRangeTrait;
use Mirakl\Core\Request\PageableTrait;
use Mirakl\Core\Request\SortableTrait;
use Mirakl\MMP\OperatorShop\Domain\Collection\Invoice\InvoiceCollection;

/**
 * (IV01) List invoices
 * Note: this resource supports pagination and will return 10 invoices
 * Type of the accounting document for filtering.
 * Default value is AUTO_INVOICE which represent invoices generated by shop payment.
 *
 * @method  string  getCurrency()
 * @method  $this   setCurrency(string $currency)   Currency ISO code for filtering
 * @method  array   getStates()
 * @method  $this   setStates(array $states)
 * @method  string  getType()
 * @method  $this   setType(string $type)
 */
abstract class AbstractGetInvoicesRequest extends AbstractRequest
{
    use DateRangeTrait;
    use PageableTrait;
    use SortableTrait;

    /**
     * @var string
     */
    protected $endpoint = '/invoices';

    /**
     * @var array
     */
    public $queryParams = ['type', 'currency'];

    /**
     * @inheritdoc
     */
    public function getResponseDecorator()
    {
        return InvoiceCollection::decorator('invoices');
    }
}